﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Syncfusion.Pdf;
using Syncfusion.Pdf.Parsing;
using Syncfusion.Pdf.Security;
using Syncfusion.Pdf.Graphics;
using System.IO;
using System.Diagnostics;
using System.Drawing;
using Syncfusion.Pdf.Interactive;

namespace DigitalSignatureSample
{
    class Program
    {
        static void Main(string[] args)
        {
            //Load PDF document 
            PdfLoadedDocument document = new PdfLoadedDocument("../../Data/Barcode.pdf");

            //Get loaded page
            PdfLoadedPage page = document.Pages[0] as PdfLoadedPage;

            //Creates a signature field
            PdfSignatureField signatureField = new PdfSignatureField(page, "SignatureField");
            
            //Add siganture 
            signatureField.Bounds = new RectangleF(0, 0, 100, 100);
            signatureField.Signature = new PdfSignature(document, page, new PdfCertificate(@"../../Data/PDF.pfx", "syncfusion"), "Signature");
            signatureField.Signature.Reason = "I am author of this document";

            //Save the document 
            document.Save();
            //Closes the document
            document.Close(true);

            //Load the documet 
            PdfLoadedDocument loadedDocument = new PdfLoadedDocument("../../Data/Barcode.pdf");

            //Gets the page of the document
            PdfLoadedPage page1 = loadedDocument.Pages[0] as PdfLoadedPage;

            //Gets the first signature field of the PDF document.
            PdfLoadedSignatureField field2 = loadedDocument.Form.Fields[0] as PdfLoadedSignatureField;

            //Validate signature and get the validation result
            PdfSignatureValidationResult result = field2.ValidateSignature();

            bool isDocumentModified = result.IsDocumentModified;
            
            //Get PDF Certificate instance from signature field
            PdfCertificate certificate = field2.Signature.Certificate;

            //Get the certificate details
            string subjectName = certificate.SubjectName;
            string issuerName = certificate.IssuerName;
        }
    }
}
